VERSION 5.00
Begin VB.Form frmInspector 
   Caption         =   "PropTabs Inspector"
   ClientHeight    =   5505
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   8160
   LinkTopic       =   "Form1"
   ScaleHeight     =   5505
   ScaleWidth      =   8160
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtOut 
      BorderStyle     =   0  'None
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   9
         Charset         =   204
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   5325
      Left            =   0
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   0
      Top             =   0
      Width           =   7965
   End
End
Attribute VB_Name = "frmInspector"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' 
Private Const SEE_MASK_INVOKEIDLIST = &HC
Private Const SEE_MASK_NOCLOSEPROCESS = &H40
Private Const SEE_MASK_FLAG_NO_UI = &H400
'    
Private Type SHELLEXECUTEINFO
    cbSize As Long
    fMask As Long
    hwnd As Long
    lpVerb As String
    lpFile As String
    lpParameters As String
    lpDirectory As String
    nShow As Long
    hInstApp As Long
    lpIDList As Long
    lpClass As String
    hkeyClass As Long
    dwHotKey As Long
    hIcon As Long
    hProcess As Long
End Type

Private Const SW_SHOWNORMAL = 1

Private Declare Function ShellExecuteEx Lib "shell32.dll" (sei As SHELLEXECUTEINFO) As Long
Private Declare Function FindWindow Lib "user32.dll" Alias "FindWindowA" (ByVal lpClassName As String, ByVal lpWindowName As String) As Long
Private Declare Function FindWindowEx Lib "user32.dll" Alias "FindWindowExA" (ByVal hWnd1 As Long, ByVal hWnd2 As Long, ByVal lpsz1 As String, ByVal lpsz2 As String) As Long
Private Declare Function GetWindowText Lib "user32" Alias "GetWindowTextA" (ByVal hwnd As Long, ByVal lpString As String, ByVal cch As Long) As Long
Private Declare Function GetWindowTextLength Lib "user32.dll" Alias "GetWindowTextLengthA" (ByVal hwnd As Long) As Long
Private Declare Function GetWindowThreadProcessId Lib "user32.dll" (ByVal hwnd As Long, ByRef lpdwProcessId As Long) As Long
Private Declare Function GetCurrentProcessId Lib "kernel32.dll" () As Long
Private Declare Function GetClassName Lib "user32" Alias "GetClassNameA" (ByVal hwnd As Long, ByVal lpClassName As String, ByVal nMaxCount As Long) As Long
Private Declare Function SendMessage Lib "user32.dll" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByRef lParam As Any) As Long
Private Declare Function IsWindowVisible Lib "user32.dll" (ByVal hwnd As Long) As Long
Private Declare Function GetSystemMetrics Lib "user32" (ByVal nIndex As Long) As Long
Private Declare Function DestroyWindow Lib "user32.dll" (ByVal hwnd As Long) As Long

Private Const TCM_FIRST As Long = &H1300
Private Const TCM_SETCURFOCUS As Long = (TCM_FIRST + 48)
Private Const TCM_GETITEMCOUNT As Long = (TCM_FIRST + 4)
Private Const TCM_GETITEMA As Long = (TCM_FIRST + 5)
Private Const TCIF_TEXT = &H1

Private Type TCITEM
    mask As Long
    dwState As Long
    dwStateMask As Long
    pszText As String
    cchTextMax As Long
    iImage As Long

    lParam As Long
End Type

Private Const LVM_FIRST As Long = &H1000
Private Const LVM_GETITEMCOUNT As Long = (LVM_FIRST + 4)
Private Const LVM_GETITEMA As Long = (LVM_FIRST + 5)

Private Declare Function GetOpenFileName Lib "comdlg32.dll" Alias "GetOpenFileNameA" (pOpenfilename As OPENFILENAME) As Long
Private Type OPENFILENAME
    lStructSize As Long
    hwndOwner As Long
    hInstance As Long
    lpstrFilter As String
    lpstrCustomFilter As String
    nMaxCustFilter As Long
    nFilterIndex As Long
    lpstrFile As String
    nMaxFile As Long
    lpstrFileTitle As String
    nMaxFileTitle As Long
    lpstrInitialDir As String
    lpstrTitle As String
    flags As Long
    nFileOffset As Integer
    nFileExtension As Integer
    lpstrDefExt As String
    lCustData As Long
    lpfnHook As Long
    lpTemplateName As String
End Type

Private Const WM_CLOSE As Long = &H10

Private Type LVITEM
    mask As Long
    iItem As Long
    iSubItem As Long
    state As Long
    stateMask As Long
    pszText As String
    cchTextMax As Long
    iImage As Long
    lParam As Long
    iIndent As Long
End Type

Private Const LVIF_TEXT As Long = &H1
Private Const LVIF_COLUMNS As Long = &H200

Private Type LVCOLUMN
    mask As Long
    fmt As Long
    cx As Long
    pszText As String
    cchTextMax As Long
    iSubItem As Long
    iImage As Long
    iOrder As Long
End Type

Private Const LVM_GETCOLUMNA As Long = (LVM_FIRST + 25)
Private Const LVCF_TEXT As Long = &H4

Private Const BM_CLICK As Long = &HF5&

Private Function GetFile() As String
    Dim OFName As OPENFILENAME
    OFName.lStructSize = Len(OFName)
    OFName.hwndOwner = Me.hwnd
    OFName.hInstance = App.hInstance
    OFName.lpstrFilter = "All Files (*.*)" + Chr$(0) + "*.*" + Chr$(0)
    OFName.lpstrFile = Space$(254)
    OFName.nMaxFile = 255
    OFName.lpstrFileTitle = Space$(254)
    OFName.nMaxFileTitle = 255
    OFName.lpstrInitialDir = CurDir
    OFName.lpstrTitle = "Select File to Examine"
    OFName.flags = 0

    If GetOpenFileName(OFName) Then
        GetFile = Trim$(OFName.lpstrFile)
    End If
End Function

Private Sub Perform()
On Error Resume Next

    DebugClear
    
    Dim LV As Boolean

    Dim sei As SHELLEXECUTEINFO
    With sei
        '  
        .cbSize = Len(sei)
        '  
        .fMask = SEE_MASK_NOCLOSEPROCESS Or _
         SEE_MASK_INVOKEIDLIST Or SEE_MASK_FLAG_NO_UI
        ' hWnd -
        .hwnd = Me.hwnd
        ' 
        .lpVerb = "properties"
        '  
        .lpFile = GetFile
        .lpParameters = vbNullChar
        .lpDirectory = vbNullChar
        .nShow = 0
        .hInstApp = 0
        .lpIDList = 0
        If Len(.lpFile) = 0 Then Exit Sub
    End With
    Dim r As Long
    r = ShellExecuteEx(sei)
    If sei.hInstApp <= 32 Then Exit Sub
       
    Dim s1 As String
    
    Dim lFound As Long, lN As Long, lDial As Long, s2 As String
    
    Do
        lDial = FindDial
    Loop Until lDial <> 0
    
    s1 = String(GetWindowTextLength(lDial), Chr(0))
    GetWindowText lDial, s1, Len(s1) + 1
    DebugPrint "Examining Tabs of Property Sheet for:"
    DebugPrint sei.lpFile
    DebugPrint
    DebugPrint "Dialog_hWnd = " & Trim$(Str$(lDial))
    DebugPrint "Dialog_Caption = " & Chr(34) & s1 & Chr(34)
    s1 = vbNullString
    
    Dim lThWnd As Long, lDia As Long
    
    Do
        lFound = FindWindowEx(lDial, lFound, vbNullString, vbNullString)
        If lFound <> 0 Then
            s1 = String$(256, Chr(0))
            GetClassName lFound, s1, 256
            s1 = UCase$(Mid$(s1, 1, InStr(1, s1, Chr(0)) - 1))
            If s1 = "SYSTABCONTROL32" Then
                DebugPrint "Tabs_hWnd = " & Trim$(Str$(lFound))
                lThWnd = lFound
                Exit Do
            End If
        End If
    Loop Until lFound = 0
    
    Dim f As Long, l As Long
    l = SendMessage(lThWnd, TCM_GETITEMCOUNT, ByVal 0&, ByVal 0&)
    
    Dim tci As TCITEM
    Dim lB As Long, lBCount As Long, nTab As Long
    
    DebugPrint
    
    Dim bSet As Boolean
    
    nTab = -1
    
    For f = 0 To l - 1
        SendMessage lThWnd, TCM_SETCURFOCUS, f, ByVal 0&
        
        tci.pszText = String(256, Chr(0))
        tci.mask = TCIF_TEXT
        tci.cchTextMax = 257
        If SendMessage(lThWnd, TCM_GETITEMA, f, tci) = 1 Then           
            '   ""!
            If Mid$(tci.pszText, 1, InStr(1, tci.pszText, Chr(0)) - 1) = "" _
            Then nTab = f
        End If
        
        Dim lLv As Long, nLv As Long, ocv As Collection, cv As Collection
        Dim lCpc As Long
        
        lFound = 0
        lCpc = 0
        
        Set ocv = New Collection
        
        Do
            lFound = FindWindowEx(lDial, lFound, vbNullString, vbNullString)
            If lFound <> 0 Then
                s1 = String$(256, Chr(0))
                GetClassName lFound, s1, 256
                s1 = UCase$(Mid$(s1, 1, InStr(1, s1, Chr(0)) - 1))
                If s1 = "#32770" And IsWindowVisible(lFound) = 1 Then
                    lCpc = lCpc + 1
                    Dim lF As Long
                    lF = 0
                    Do
                        lF = FindWindowEx(lFound, lF, vbNullString, vbNullString)
                        If lF <> 0 Then   
                                Dim lF2 As Long
                                Dim bStartS As Boolean, sp As String
ReTry:
                                Do
                                    lF2 = FindWindowEx(lF, lF2, vbNullString, vbNullString)
                                    If lF2 <> 0 Then
                                        s2 = String$(256, Chr(0))
                                        GetClassName lF2, s2, 256
                                        s2 = UCase$(Mid$(s2, 1, InStr(1, s2, Chr(0)) - 1))
                                        If s2 = "STATIC" Or s2 = "EDIT" Then
                                            s1 = String(GetWindowTextLength(lF2), Chr(0))
                                            GetWindowText lF2, s1, Len(s1) + 1
                                            If s2 = "STATIC" Then
                                                If Len(s1) Then
                                                    sp = s1
                                                    bStartS = True
                                                End If
                                            Else
                                                If bStartS Then
                                                    bStartS = False
                                                End If
                                            End If
                                        ElseIf s2 = "SYSLISTVIEW32" Then
                                            If lF2 <> 0 Then lLv = lF2
                                        ElseIf s2 = "BUTTON" Then
                                            If Not LV Then
                                                lB = lF2
                                                lBCount = lBCount + 1
                                            End If
                                        End If
                                    End If
                                Loop Until lF2 = 0
                                
                                If lBCount = 1 And Not LV And nTab = -1 And bSet = False Then
                                    bSet = True
                                    nTab = f
                                    Set cv = ocv
                                    LV = True
                                    lBCount = 0
                                    SendMessage lB, BM_CLICK, 0, 0
                                    GoTo ReTry
                                End If
                                lBCount = 0
                        End If
                    Loop Until lF = 0
                End If
            End If
        Loop Until lFound = 0
        
        If nTab <> -1 Then Exit For
        
    Next
    
    Set ocv = Nothing
    
    DebugPrint "Related data is contained in the tab #" & Trim$(Str$(nTab + 1))
    
    DumpData lLv, cv
    
    Set cv = Nothing
    
    DebugTrim
    SendMessage lDial, WM_CLOSE, ByVal 0&, ByVal 0&
    Me.SetFocus
End Sub

Private Function FindDial() As Long
    '  
    Dim lDial As Long, lPId As Long, lPId2 As Long
    Do
        lDial = FindWindowEx(0, lDial, "#32770", vbNullString)
        GetWindowThreadProcessId lDial, lPId
        GetWindowThreadProcessId Me.hwnd, lPId2
        
        If lPId = lPId2 Then Exit Do
    Loop Until lDial = 0
    FindDial = lDial
End Function

Private Sub Form_Load()
    DebugPrint "Double-click to start!"
End Sub

Private Sub Form_Resize()
    If Me.WindowState = vbMinimized Then Exit Sub
    
    Const SM_CXFRAME As Long = 32
    Const SM_CYFRAME As Long = 33
    
    Const SM_CYCAPTION As Long = 4
       
    Me.txtOut.Width = Me.Width - 2 * (GetSystemMetrics(SM_CXFRAME) * Screen.TwipsPerPixelX)
    Me.txtOut.Height = Me.Height - 2 * (GetSystemMetrics(SM_CYFRAME) * Screen.TwipsPerPixelY) - GetSystemMetrics(SM_CYCAPTION) * Screen.TwipsPerPixelY
End Sub

Private Sub DebugPrint(Optional sData As String = "", Optional bNoLine As Boolean)
    Me.txtOut.Text = Me.txtOut.Text & sData
    If Not bNoLine Then
        Me.txtOut.Text = Me.txtOut.Text & vbNewLine
    End If
End Sub

Private Sub txtOut_DblClick()
    Perform
End Sub

Private Sub DebugClear()
    Me.txtOut.Text = vbNullString
End Sub

Private Sub DebugTrim()
    If Left$(Me.txtOut.Text, 2) = vbNewLine Then Me.txtOut.Text = Mid$(Me.txtOut.Text, 3)
    If Right$(Me.txtOut.Text, 2) = vbNewLine Then Me.txtOut.Text = Mid$(Me.txtOut.Text, 1, Len(Me.txtOut.Text) - 2)
End Sub

Private Sub DumpListView(lF As Long, Optional bForce As Boolean = False, Optional bToColl As Boolean = False, Optional oColl As Collection = Nothing)
    Dim n As Long, j As Long, sT As String
    Static lvLast As Long
    If lF = lvLast And bForce = False Then Exit Sub
    lvLast = lF
    n = SendMessage(lF, LVM_GETITEMCOUNT, ByVal 0&, ByVal 0&)
    Dim itm As LVITEM, f As Long, sText As String
    itm.mask = LVIF_TEXT
    If Not bToColl Then DebugPrint Trim$(Str$(lF)) & " - (ListView):"
    For j = 0 To n - 1
        itm.iItem = j
        itm.cchTextMax = 65536
        itm.pszText = String(65535, Chr(0))
        
        Dim lc As LVCOLUMN, c As Long
        lc.mask = LVCF_TEXT
        f = 0
        c = 0
        Do
            lc.cchTextMax = 65536
            lc.pszText = String$(65535, Chr(0))
            If SendMessage(lF, LVM_GETCOLUMNA, f, lc) = 1 Then
                If Len(Mid$(lc.pszText, 1, InStr(1, lc.pszText, Chr(0)) - 1)) > 0 Then
                    c = c + 1
                    f = f + 1
                Else
                    Exit Do
                End If
            Else
                Exit Do
            End If
        Loop
        
        If c = 0 Then c = 1
        
        For f = 0 To c - 1
            itm.iSubItem = f
            SendMessage lF, LVM_GETITEMA, ByVal 0&, itm
            sText = Mid$(itm.pszText, 1, InStr(1, itm.pszText, Chr(0)) - 1)
            If Len(sText) Then
                If f = 0 Then
                    If Not bToColl Then
                        DebugPrint vbTab & "Item #" & Trim$(Str$(j + 1)) & " = " & Chr(34) & sText & Chr(34), True
                    Else
                        sT = sText & Chr(0)
                    End If
                Else
                    If Not bToColl Then
                        DebugPrint ", " & Chr(34) & sText & Chr(34), True
                    Else
                        sT = sT & sText & Chr(0)
                    End If
                End If
            Else
                If Not bToColl Then
                    DebugPrint ", " & Chr(34) & Chr(34), True
                Else
                    sT = sT & Chr(0)
                End If
            End If
        Next f
        If Not bToColl Then
            DebugPrint
        Else
            oColl.Add sT, Mid$(sT, 1, InStr(1, sT, Chr(0)) - 1)
        End If
    Next
End Sub

Private Sub DumpData(lF As Long, oColl As Collection)
On Error Resume Next
    Dim c
    Dim f As Collection, f2 As Collection
    Set f = New Collection
    Set f2 = New Collection
    For Each c In oColl
        DebugPrint Filtr(Mid$(c, 1, InStr(1, c, Chr(0)) - 1)) & _
        " " & Mid$(c, InStr(1, c, Chr(0)) + 1, Len(c) - _
        InStr(1, c, Chr(0)) - 1)
        f.Add "#", Filtr(Mid$(c, 1, InStr(1, c, Chr(0)) - 1))
    Next c
    DumpListView lF, True, True, f2
    For Each c In f2
        Dim z As String
        Err.Clear
        z = f(Filtr(Mid$(c, 1, InStr(1, c, Chr(0)) - 1)) & ":")
        If Err <> 0 Then
            DebugPrint Filtr(Mid$(c, 1, InStr(1, c, Chr(0)) - 1)) & ":" & _
            " " & Mid$(c, InStr(1, c, Chr(0)) + 1, Len(c) - _
            InStr(1, c, Chr(0)) - 1)
        End If
        Err.Clear
    Next c
    Set f = Nothing
    Set f2 = Nothing
End Sub

Private Function Filtr(sIn As String) As String
    Dim sRepl As String
    Dim aPattern() As String
    Dim aRepl() As String
    
    ReDim aPattern(0)
    aPattern(0) = "&"
    ReDim aRepl(UBound(aPattern))
    
    Filtr = sIn
    
    sRepl = sIn
    
    Dim i As Long
    For i = 0 To UBound(aPattern)
        sRepl = VBA.Replace(sRepl, aPattern(i), aRepl(i))
        If Len(sRepl) > 0 Then
            sIn = sRepl
        Else
            sRepl = sIn
        End If
    Next
    Filtr = sIn
End Function
